/*
 * Copyright (c) 2012, Jonas Widén (jonas.widen@widens.eu)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef NEXA_NEW_H_
#define NEXA_NEW_H_

#include <stdint.h>
#include <stdbool.h>

typedef enum {
  NEXA_ACTIVATION_OFF,
  NEXA_ACTIVATION_ON,
  NEXA_ACTIVATION_DIM
} nexa_activation_t;

typedef enum {
  NEXA_DIM_LEVEL_1,
  NEXA_DIM_LEVEL_2,
  NEXA_DIM_LEVEL_3,
  NEXA_DIM_LEVEL_4,
  NEXA_DIM_LEVEL_5,
  NEXA_DIM_LEVEL_6,
  NEXA_DIM_LEVEL_7,
  NEXA_DIM_LEVEL_8,
  NEXA_DIM_LEVEL_9,
  NEXA_DIM_LEVEL_10,
  NEXA_DIM_LEVEL_11,
  NEXA_DIM_LEVEL_12,
  NEXA_DIM_LEVEL_13,
  NEXA_DIM_LEVEL_14,
  NEXA_DIM_LEVEL_15,
  NEXA_DIM_LEVEL_16
} nexa_dim_level_t;

typedef enum {
  NEXA_CHANNEL_1,
  NEXA_CHANNEL_2,
  NEXA_CHANNEL_3,
  NEXA_CHANNEL_4
} nexa_channel_t;

typedef enum {
  NEXA_BUTTON_1,
  NEXA_BUTTON_2,
  NEXA_BUTTON_3,
  NEXA_BUTTON_4
} nexa_button_t;

void nexa_new_init(void);
void nexa_new_transmit(nexa_channel_t channel,
                       nexa_button_t button,
                       nexa_activation_t activation,
                       nexa_dim_level_t level,
                       bool group_mode);

#endif /* NEXA_NEW_H_ */
